/* DatabaseTable.c generated by valac 0.32.0, the Vala compiler
 * generated from DatabaseTable.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
typedef struct _ParamSpecDatabaseTable ParamSpecDatabaseTable;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _ParamSpecDatabaseTable {
	GParamSpec parent_instance;
};


static gpointer database_table_parent_class = NULL;
extern sqlite3* database_table_db;
sqlite3* database_table_db = NULL;
static gint database_table_in_transaction;
static gint database_table_in_transaction = 0;

GQuark database_error_quark (void);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
enum  {
	DATABASE_TABLE_DUMMY_PROPERTY
};
#define DATABASE_TABLE_SCHEMA_VERSION 20
static void database_table_prepare_db (const gchar* filename);
void app_window_panic (const gchar* msg);
#define DB_IN_MEMORY_NAME ":memory:"
void database_table_init (const gchar* filename);
void database_table_warning (const gchar* op, gint res);
void database_table_terminate (void);
void database_table_fatal (const gchar* op, gint res);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
void database_table_throw_error (const gchar* method, gint res, GError** error);
gboolean database_table_exists_by_id (DatabaseTable* self, gint64 id);
gboolean database_table_select_by_id (DatabaseTable* self, gint64 id, const gchar* columns, sqlite3_stmt** stmt);
static void database_table_prepare_update_by_id (DatabaseTable* self, gint64 id, const gchar* column, sqlite3_stmt** stmt);
static gboolean database_table_execute_update_by_id (DatabaseTable* self, sqlite3_stmt* stmt);
gboolean database_table_update_text_by_id (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
gboolean database_table_update_int_by_id (DatabaseTable* self, gint64 id, const gchar* column, gint value);
void database_table_update_int_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint value, GError** error);
gboolean database_table_update_int64_by_id (DatabaseTable* self, gint64 id, const gchar* column, gint64 value);
void database_table_update_int64_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint64 value, GError** error);
void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error);
gboolean database_table_has_column (const gchar* table_name, const gchar* column_name);
gboolean database_table_has_table (const gchar* table_name);
gboolean database_table_add_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints);
gboolean database_table_ensure_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints, const gchar* upgrade_msg);
gint database_table_get_row_count (DatabaseTable* self);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
DatabaseTable* database_table_construct (GType object_type);
static void database_table_finalize (DatabaseTable* obj);


GQuark database_error_quark (void) {
	return g_quark_from_static_string ("database_error-quark");
}


static void database_table_prepare_db (const gchar* filename) {
	gint res = 0;
	const gchar* _tmp0_ = NULL;
	sqlite3* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	const gchar* _tmp9_ = NULL;
	GError * _inner_error_ = NULL;
#line 32 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (filename != NULL);
#line 34 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = filename;
#line 34 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = sqlite3_open_v2 (_tmp0_, &_tmp1_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 34 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_close0 (database_table_db);
#line 34 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_db = _tmp1_;
#line 34 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp2_;
#line 36 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = res;
#line 36 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp3_ != SQLITE_OK) {
#line 146 "DatabaseTable.c"
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 37 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp4_ = _ ("Unable to open/create photo database %s: error code %d");
#line 37 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp5_ = filename;
#line 37 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp6_ = res;
#line 37 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp7_ = g_strdup_printf (_tmp4_, _tmp5_, _tmp6_);
#line 37 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp8_ = _tmp7_;
#line 37 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		app_window_panic (_tmp8_);
#line 37 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_g_free0 (_tmp8_);
#line 166 "DatabaseTable.c"
	}
#line 41 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = filename;
#line 41 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (g_strcmp0 (_tmp9_, DB_IN_MEMORY_NAME) != 0) {
#line 172 "DatabaseTable.c"
		{
			GFile* file_db = NULL;
			const gchar* _tmp10_ = NULL;
			GFile* _tmp11_ = NULL;
			GFileInfo* info = NULL;
			GFile* _tmp12_ = NULL;
			GFileInfo* _tmp13_ = NULL;
			GFileInfo* _tmp14_ = NULL;
			gboolean _tmp15_ = FALSE;
#line 43 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp10_ = filename;
#line 43 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp11_ = g_file_new_for_path (_tmp10_);
#line 43 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			file_db = _tmp11_;
#line 44 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp12_ = file_db;
#line 44 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp13_ = g_file_query_info (_tmp12_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
#line 44 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			info = _tmp13_;
#line 44 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 44 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_object_unref0 (file_db);
#line 198 "DatabaseTable.c"
				goto __catch13_g_error;
			}
#line 45 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp14_ = info;
#line 45 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp15_ = g_file_info_get_attribute_boolean (_tmp14_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
#line 45 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (!_tmp15_) {
#line 207 "DatabaseTable.c"
				const gchar* _tmp16_ = NULL;
				const gchar* _tmp17_ = NULL;
				gchar* _tmp18_ = NULL;
				gchar* _tmp19_ = NULL;
#line 46 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_tmp16_ = _ ("Unable to write to photo database file:\n %s");
#line 46 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_tmp17_ = filename;
#line 46 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_tmp18_ = g_strdup_printf (_tmp16_, _tmp17_);
#line 46 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_tmp19_ = _tmp18_;
#line 46 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				app_window_panic (_tmp19_);
#line 46 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (_tmp19_);
#line 224 "DatabaseTable.c"
			}
#line 42 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_g_object_unref0 (info);
#line 42 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_g_object_unref0 (file_db);
#line 230 "DatabaseTable.c"
		}
		goto __finally13;
		__catch13_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp20_ = NULL;
			const gchar* _tmp21_ = NULL;
			GError* _tmp22_ = NULL;
			const gchar* _tmp23_ = NULL;
			gchar* _tmp24_ = NULL;
			gchar* _tmp25_ = NULL;
#line 42 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			e = _inner_error_;
#line 42 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_inner_error_ = NULL;
#line 48 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp20_ = _ ("Error accessing database file:\n %s\n\nError was: \n%s");
#line 48 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp21_ = filename;
#line 48 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp22_ = e;
#line 48 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp23_ = _tmp22_->message;
#line 48 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp24_ = g_strdup_printf (_tmp20_, _tmp21_, _tmp23_);
#line 48 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp25_ = _tmp24_;
#line 48 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			app_window_panic (_tmp25_);
#line 48 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_g_free0 (_tmp25_);
#line 42 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_g_error_free0 (e);
#line 264 "DatabaseTable.c"
		}
		__finally13:
#line 42 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 42 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 42 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			g_clear_error (&_inner_error_);
#line 42 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			return;
#line 275 "DatabaseTable.c"
		}
	}
}


static gint _sqlite3_exec (sqlite3* self, const gchar* sql, sqlite3_callback callback, void* callback_target, gchar** errmsg) {
	gchar* _vala_errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	sqlite3_callback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	const gchar* _tmp6_ = NULL;
#line 34 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	_tmp0_ = sql;
#line 36 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	_tmp1_ = callback;
#line 36 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	_tmp1__target = callback_target;
#line 36 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	_tmp3_ = sqlite3_exec (self, _tmp0_, _tmp1_, _tmp1__target, (char**) (&_tmp2_));
#line 36 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	sqlite_errmsg = _tmp2_;
#line 36 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	ec = _tmp3_;
#line 37 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 310 "DatabaseTable.c"
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
#line 38 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
		_tmp4_ = sqlite_errmsg;
#line 38 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
		_tmp5_ = g_strdup (_tmp4_);
#line 38 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
		_vala_errmsg = _tmp5_;
#line 321 "DatabaseTable.c"
	}
#line 40 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	_tmp6_ = sqlite_errmsg;
#line 40 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	sqlite3_free ((void*) _tmp6_);
#line 41 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	result = ec;
#line 41 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	if (errmsg) {
#line 41 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 333 "DatabaseTable.c"
	} else {
#line 41 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 337 "DatabaseTable.c"
	}
#line 41 "/usr/share/vala-0.32/vapi/sqlite3.vapi"
	return result;
#line 341 "DatabaseTable.c"
}


void database_table_init (const gchar* filename) {
	const gchar* _tmp0_ = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	sqlite3* _tmp19_ = NULL;
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	GError * _inner_error_ = NULL;
#line 54 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (filename != NULL);
#line 56 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = filename;
#line 56 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_prepare_db (_tmp0_);
#line 60 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = database_table_db;
#line 60 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = sqlite3_prepare_v2 (_tmp1_, "CREATE TABLE IF NOT EXISTS VersionTable (" "id INTEGER PRIMARY KEY, " "schema_version INTEGER, " "app_version TEXT, " "user_data TEXT NULL" ")", -1, &_tmp2_, NULL);
#line 60 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 60 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp2_;
#line 60 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp3_;
#line 68 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp4_ = res;
#line 68 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp4_ != SQLITE_OK) {
#line 377 "DatabaseTable.c"
		gchar* backup_path = NULL;
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 69 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_sqlite3_close0 (database_table_db);
#line 69 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_db = NULL;
#line 71 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp5_ = filename;
#line 71 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp6_ = g_strconcat (_tmp5_, ".bak", NULL);
#line 71 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		backup_path = _tmp6_;
#line 391 "DatabaseTable.c"
		{
			GFile* src = NULL;
			const gchar* _tmp7_ = NULL;
			GFile* _tmp8_ = NULL;
			GFile* dest = NULL;
			const gchar* _tmp9_ = NULL;
			GFile* _tmp10_ = NULL;
			GFile* _tmp11_ = NULL;
			GFile* _tmp12_ = NULL;
			const gchar* _tmp13_ = NULL;
#line 74 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp7_ = backup_path;
#line 74 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp8_ = g_file_new_for_commandline_arg (_tmp7_);
#line 74 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			src = _tmp8_;
#line 75 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp9_ = filename;
#line 75 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp10_ = g_file_new_for_commandline_arg (_tmp9_);
#line 75 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			dest = _tmp10_;
#line 76 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp11_ = src;
#line 76 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp12_ = dest;
#line 76 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			g_file_copy (_tmp11_, _tmp12_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error_);
#line 76 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 76 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_object_unref0 (dest);
#line 76 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_object_unref0 (src);
#line 426 "DatabaseTable.c"
				goto __catch14_g_error;
			}
#line 79 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp13_ = filename;
#line 79 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			database_table_prepare_db (_tmp13_);
#line 73 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_g_object_unref0 (dest);
#line 73 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_g_object_unref0 (src);
#line 437 "DatabaseTable.c"
		}
		goto __finally14;
		__catch14_g_error:
		{
			GError* _error_ = NULL;
			const gchar* _tmp14_ = NULL;
			GError* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			gchar* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
#line 73 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_error_ = _inner_error_;
#line 73 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_inner_error_ = NULL;
#line 81 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp14_ = _ ("Unable to restore photo database %s");
#line 81 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp15_ = _error_;
#line 81 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp16_ = _tmp15_->message;
#line 81 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp17_ = g_strdup_printf (_tmp14_, _tmp16_);
#line 81 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp18_ = _tmp17_;
#line 81 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			app_window_panic (_tmp18_);
#line 81 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_g_free0 (_tmp18_);
#line 73 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_g_error_free0 (_error_);
#line 468 "DatabaseTable.c"
		}
		__finally14:
#line 73 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 73 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_g_free0 (backup_path);
#line 73 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_sqlite3_finalize0 (stmt);
#line 73 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 73 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			g_clear_error (&_inner_error_);
#line 73 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			return;
#line 483 "DatabaseTable.c"
		}
#line 68 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_g_free0 (backup_path);
#line 487 "DatabaseTable.c"
	}
#line 87 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp19_ = database_table_db;
#line 87 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp20_ = _sqlite3_exec (_tmp19_, "PRAGMA synchronous=OFF", NULL, NULL, NULL);
#line 87 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp20_;
#line 88 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp21_ = res;
#line 88 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp21_ != SQLITE_OK) {
#line 499 "DatabaseTable.c"
		gint _tmp22_ = 0;
#line 89 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp22_ = res;
#line 89 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_warning ("Unable to disable synchronous mode", _tmp22_);
#line 505 "DatabaseTable.c"
	}
#line 54 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 509 "DatabaseTable.c"
}


void database_table_terminate (void) {
#line 94 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_close0 (database_table_db);
#line 94 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_db = NULL;
#line 518 "DatabaseTable.c"
}


void database_table_fatal (const gchar* op, gint res) {
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	sqlite3* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
#line 98 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (op != NULL);
#line 99 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = op;
#line 99 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = res;
#line 99 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 99 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = sqlite3_errmsg (_tmp2_);
#line 99 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_error ("DatabaseTable.vala:99: %s: [%d] %s", _tmp0_, _tmp1_, _tmp3_);
#line 539 "DatabaseTable.c"
}


void database_table_warning (const gchar* op, gint res) {
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	sqlite3* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
#line 103 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (op != NULL);
#line 104 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = op;
#line 104 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = res;
#line 104 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 104 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = sqlite3_errmsg (_tmp2_);
#line 104 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_warning ("DatabaseTable.vala:104: %s: [%d] %s", _tmp0_, _tmp1_, _tmp3_);
#line 560 "DatabaseTable.c"
}


void database_table_set_table_name (DatabaseTable* self, const gchar* table_name) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 107 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 107 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (table_name != NULL);
#line 108 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = table_name;
#line 108 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 108 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_g_free0 (self->table_name);
#line 108 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	self->table_name = _tmp1_;
#line 579 "DatabaseTable.c"
}


void database_table_throw_error (const gchar* method, gint res, GError** error) {
	gchar* msg = NULL;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	sqlite3* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	GError * _inner_error_ = NULL;
#line 113 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (method != NULL);
#line 114 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = method;
#line 114 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = res;
#line 114 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 114 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = sqlite3_errmsg (_tmp2_);
#line 114 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp4_ = g_strdup_printf ("(%s) [%d] - %s", _tmp0_, _tmp1_, _tmp3_);
#line 114 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	msg = _tmp4_;
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = res;
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	switch (_tmp5_) {
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_OK:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_DONE:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_ROW:
#line 616 "DatabaseTable.c"
		{
#line 120 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_g_free0 (msg);
#line 120 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			return;
#line 622 "DatabaseTable.c"
		}
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_PERM:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_BUSY:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_READONLY:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_IOERR:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_CORRUPT:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_CANTOPEN:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_NOLFS:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_AUTH:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_FORMAT:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_NOTADB:
#line 644 "DatabaseTable.c"
		{
			const gchar* _tmp6_ = NULL;
			GError* _tmp7_ = NULL;
#line 132 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp6_ = msg;
#line 132 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp7_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_BACKING, _tmp6_);
#line 132 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp7_;
#line 132 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 132 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 132 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 132 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 662 "DatabaseTable.c"
			} else {
#line 132 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 132 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 132 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 132 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 672 "DatabaseTable.c"
			}
		}
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_NOMEM:
#line 677 "DatabaseTable.c"
		{
			const gchar* _tmp8_ = NULL;
			GError* _tmp9_ = NULL;
#line 135 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp8_ = msg;
#line 135 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp9_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_MEMORY, _tmp8_);
#line 135 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp9_;
#line 135 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 135 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 135 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 135 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 695 "DatabaseTable.c"
			} else {
#line 135 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 135 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 135 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 135 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 705 "DatabaseTable.c"
			}
		}
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_ABORT:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_LOCKED:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_INTERRUPT:
#line 714 "DatabaseTable.c"
		{
			const gchar* _tmp10_ = NULL;
			GError* _tmp11_ = NULL;
#line 140 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp10_ = msg;
#line 140 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp11_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ABORT, _tmp10_);
#line 140 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp11_;
#line 140 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 140 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 140 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 140 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 732 "DatabaseTable.c"
			} else {
#line 140 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 140 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 140 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 140 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 742 "DatabaseTable.c"
			}
		}
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_FULL:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_EMPTY:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_TOOBIG:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_CONSTRAINT:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_RANGE:
#line 755 "DatabaseTable.c"
		{
			const gchar* _tmp12_ = NULL;
			GError* _tmp13_ = NULL;
#line 147 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp12_ = msg;
#line 147 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp13_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_LIMITS, _tmp12_);
#line 147 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp13_;
#line 147 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 147 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 147 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 147 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 773 "DatabaseTable.c"
			} else {
#line 147 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 147 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 147 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 147 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 783 "DatabaseTable.c"
			}
		}
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_SCHEMA:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_MISMATCH:
#line 790 "DatabaseTable.c"
		{
			const gchar* _tmp14_ = NULL;
			GError* _tmp15_ = NULL;
#line 151 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp14_ = msg;
#line 151 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp15_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_TYPESPEC, _tmp14_);
#line 151 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp15_;
#line 151 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 151 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 151 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 151 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 808 "DatabaseTable.c"
			} else {
#line 151 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 151 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 151 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 151 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 818 "DatabaseTable.c"
			}
		}
		default:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_ERROR:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_INTERNAL:
#line 116 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		case SQLITE_MISUSE:
#line 828 "DatabaseTable.c"
		{
			const gchar* _tmp16_ = NULL;
			GError* _tmp17_ = NULL;
#line 157 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp16_ = msg;
#line 157 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp17_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ERROR, _tmp16_);
#line 157 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_inner_error_ = _tmp17_;
#line 157 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 157 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 157 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 157 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 846 "DatabaseTable.c"
			} else {
#line 157 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 157 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 157 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 157 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 856 "DatabaseTable.c"
			}
		}
	}
#line 113 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_g_free0 (msg);
#line 862 "DatabaseTable.c"
}


gboolean database_table_exists_by_id (DatabaseTable* self, gint64 id) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	sqlite3_stmt* _tmp8_ = NULL;
	gint64 _tmp9_ = 0LL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	sqlite3_stmt* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	gboolean _tmp14_ = FALSE;
	gint _tmp15_ = 0;
	gint _tmp24_ = 0;
#line 161 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 163 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 163 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 163 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("SELECT id FROM %s WHERE id=?", _tmp1_);
#line 163 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 163 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 163 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 163 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 163 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 163 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 163 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 164 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = res;
#line 164 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 166 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 166 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = id;
#line 166 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp10_ = sqlite3_bind_int64 (_tmp8_, 1, _tmp9_);
#line 166 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp10_;
#line 167 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp11_ = res;
#line 167 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp11_ == SQLITE_OK, "res == Sqlite.OK");
#line 169 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp12_ = stmt;
#line 169 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp13_ = sqlite3_step (_tmp12_);
#line 169 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp13_;
#line 170 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp15_ = res;
#line 170 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp15_ != SQLITE_ROW) {
#line 935 "DatabaseTable.c"
		gint _tmp16_ = 0;
#line 170 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp16_ = res;
#line 170 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp14_ = _tmp16_ != SQLITE_DONE;
#line 941 "DatabaseTable.c"
	} else {
#line 170 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp14_ = FALSE;
#line 945 "DatabaseTable.c"
	}
#line 170 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp14_) {
#line 949 "DatabaseTable.c"
		gint64 _tmp17_ = 0LL;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		gint _tmp23_ = 0;
#line 171 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp17_ = id;
#line 171 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp18_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp17_);
#line 171 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp19_ = _tmp18_;
#line 171 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp20_ = self->table_name;
#line 171 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp21_ = g_strdup_printf ("exists_by_id [%s] %s", _tmp19_, _tmp20_);
#line 171 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp22_ = _tmp21_;
#line 171 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp23_ = res;
#line 171 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_fatal (_tmp22_, _tmp23_);
#line 171 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_g_free0 (_tmp22_);
#line 171 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_g_free0 (_tmp19_);
#line 977 "DatabaseTable.c"
	}
#line 173 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp24_ = res;
#line 173 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	result = _tmp24_ == SQLITE_ROW;
#line 173 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 173 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return result;
#line 987 "DatabaseTable.c"
}


gboolean database_table_select_by_id (DatabaseTable* self, gint64 id, const gchar* columns, sqlite3_stmt** stmt) {
	sqlite3_stmt* _vala_stmt = NULL;
	gboolean result = FALSE;
	gchar* sql = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gint res = 0;
	sqlite3* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	sqlite3_stmt* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	sqlite3_stmt* _tmp8_ = NULL;
	gint64 _tmp9_ = 0LL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	sqlite3_stmt* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	gboolean _tmp14_ = FALSE;
	gint _tmp15_ = 0;
	gint _tmp25_ = 0;
#line 176 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 176 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (columns != NULL, FALSE);
#line 177 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = columns;
#line 177 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 177 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("SELECT %s FROM %s WHERE id=?", _tmp0_, _tmp1_);
#line 177 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	sql = _tmp2_;
#line 179 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = database_table_db;
#line 179 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp4_ = sql;
#line 179 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = sqlite3_prepare_v2 (_tmp3_, _tmp4_, -1, &_tmp5_, NULL);
#line 179 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (_vala_stmt);
#line 179 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_stmt = _tmp5_;
#line 179 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 180 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = res;
#line 180 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 182 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp8_ = _vala_stmt;
#line 182 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = id;
#line 182 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp10_ = sqlite3_bind_int64 (_tmp8_, 1, _tmp9_);
#line 182 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp10_;
#line 183 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp11_ = res;
#line 183 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp11_ == SQLITE_OK, "res == Sqlite.OK");
#line 185 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp12_ = _vala_stmt;
#line 185 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp13_ = sqlite3_step (_tmp12_);
#line 185 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp13_;
#line 186 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp15_ = res;
#line 186 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp15_ != SQLITE_ROW) {
#line 1063 "DatabaseTable.c"
		gint _tmp16_ = 0;
#line 186 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp16_ = res;
#line 186 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp14_ = _tmp16_ != SQLITE_DONE;
#line 1069 "DatabaseTable.c"
	} else {
#line 186 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp14_ = FALSE;
#line 1073 "DatabaseTable.c"
	}
#line 186 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp14_) {
#line 1077 "DatabaseTable.c"
		gint64 _tmp17_ = 0LL;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
		gint _tmp24_ = 0;
#line 187 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp17_ = id;
#line 187 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp18_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp17_);
#line 187 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp19_ = _tmp18_;
#line 187 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp20_ = self->table_name;
#line 187 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp21_ = columns;
#line 187 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp22_ = g_strdup_printf ("select_by_id [%s] %s %s", _tmp19_, _tmp20_, _tmp21_);
#line 187 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp23_ = _tmp22_;
#line 187 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp24_ = res;
#line 187 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_fatal (_tmp23_, _tmp24_);
#line 187 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_g_free0 (_tmp23_);
#line 187 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_g_free0 (_tmp19_);
#line 1108 "DatabaseTable.c"
	}
#line 189 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp25_ = res;
#line 189 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	result = _tmp25_ == SQLITE_ROW;
#line 189 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_g_free0 (sql);
#line 189 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (stmt) {
#line 189 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		*stmt = _vala_stmt;
#line 1120 "DatabaseTable.c"
	} else {
#line 189 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (_vala_stmt);
#line 1124 "DatabaseTable.c"
	}
#line 189 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return result;
#line 1128 "DatabaseTable.c"
}


static void database_table_prepare_update_by_id (DatabaseTable* self, gint64 id, const gchar* column, sqlite3_stmt** stmt) {
	sqlite3_stmt* _vala_stmt = NULL;
	gchar* sql = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gint res = 0;
	sqlite3* _tmp3_ = NULL;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint64 _tmp7_ = 0LL;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
#line 193 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 193 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 194 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = self->table_name;
#line 194 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = column;
#line 194 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("UPDATE %s SET %s=? WHERE id=?", _tmp0_, _tmp1_);
#line 194 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	sql = _tmp2_;
#line 196 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = database_table_db;
#line 196 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp3_, sql, -1, &_tmp4_, NULL);
#line 196 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (_vala_stmt);
#line 196 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_stmt = _tmp4_;
#line 196 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 197 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = res;
#line 197 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp6_ == SQLITE_OK, "res == Sqlite.OK");
#line 199 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = id;
#line 199 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp8_ = sqlite3_bind_int64 (_vala_stmt, 2, _tmp7_);
#line 199 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp8_;
#line 200 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = res;
#line 200 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp9_ == SQLITE_OK, "res == Sqlite.OK");
#line 193 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_g_free0 (sql);
#line 193 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (stmt) {
#line 193 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		*stmt = _vala_stmt;
#line 1188 "DatabaseTable.c"
	} else {
#line 193 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (_vala_stmt);
#line 1192 "DatabaseTable.c"
	}
}


static gboolean database_table_execute_update_by_id (DatabaseTable* self, sqlite3_stmt* stmt) {
	gboolean result = FALSE;
	gint res = 0;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 203 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 203 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (stmt != NULL, FALSE);
#line 204 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = stmt;
#line 204 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_step (_tmp0_);
#line 204 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp1_;
#line 205 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = res;
#line 205 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp2_ != SQLITE_DONE) {
#line 1217 "DatabaseTable.c"
		gint _tmp3_ = 0;
#line 206 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp3_ = res;
#line 206 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_fatal ("execute_update_by_id", _tmp3_);
#line 208 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		result = FALSE;
#line 208 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		return result;
#line 1227 "DatabaseTable.c"
	}
#line 211 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	result = TRUE;
#line 211 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return result;
#line 1233 "DatabaseTable.c"
}


gboolean database_table_update_text_by_id (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint64 _tmp0_ = 0LL;
	const gchar* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_ = NULL;
	gint res = 0;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GDestroyNotify _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gboolean _tmp7_ = FALSE;
#line 214 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 214 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 214 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 216 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = id;
#line 216 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = column;
#line 216 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, _tmp0_, _tmp1_, &_tmp2_);
#line 216 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 216 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp2_;
#line 218 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = text;
#line 218 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 218 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = g_free;
#line 218 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = sqlite3_bind_text (stmt, 1, _tmp4_, -1, _tmp5_);
#line 218 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 219 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 221 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = database_table_execute_update_by_id (self, stmt);
#line 221 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	result = _tmp7_;
#line 221 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 221 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return result;
#line 1285 "DatabaseTable.c"
}


void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error) {
	sqlite3_stmt* stmt = NULL;
	gint64 _tmp0_ = 0LL;
	const gchar* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GDestroyNotify _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	sqlite3_stmt* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	GError * _inner_error_ = NULL;
#line 224 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 224 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 224 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (text != NULL);
#line 226 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = id;
#line 226 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = column;
#line 226 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, _tmp0_, _tmp1_, &_tmp2_);
#line 226 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 226 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp2_;
#line 228 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = stmt;
#line 228 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp4_ = text;
#line 228 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 228 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = g_free;
#line 228 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = sqlite3_bind_text (_tmp3_, 1, _tmp5_, -1, _tmp6_);
#line 228 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp7_;
#line 229 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp8_ = res;
#line 229 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp8_ == SQLITE_OK, "res == Sqlite.OK");
#line 231 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = stmt;
#line 231 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp10_ = sqlite3_step (_tmp9_);
#line 231 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp10_;
#line 232 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp11_ = res;
#line 232 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp11_ != SQLITE_DONE) {
#line 1347 "DatabaseTable.c"
		const gchar* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gint _tmp16_ = 0;
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp12_ = self->table_name;
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp13_ = column;
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp14_ = g_strdup_printf ("DatabaseTable.update_text_by_id_2 %s.%s", _tmp12_, _tmp13_);
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp15_ = _tmp14_;
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp16_ = res;
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp15_, _tmp16_, &_inner_error_);
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_g_free0 (_tmp15_);
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 1377 "DatabaseTable.c"
			} else {
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 233 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 1387 "DatabaseTable.c"
			}
		}
	}
#line 224 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1393 "DatabaseTable.c"
}


gboolean database_table_update_int_by_id (DatabaseTable* self, gint64 id, const gchar* column, gint value) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint64 _tmp0_ = 0LL;
	const gchar* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_ = NULL;
	gint res = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gboolean _tmp5_ = FALSE;
#line 236 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 236 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 238 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = id;
#line 238 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = column;
#line 238 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, _tmp0_, _tmp1_, &_tmp2_);
#line 238 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 238 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp2_;
#line 240 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = value;
#line 240 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_bind_int (stmt, 1, _tmp3_);
#line 240 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp4_;
#line 241 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 243 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = database_table_execute_update_by_id (self, stmt);
#line 243 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	result = _tmp5_;
#line 243 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 243 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return result;
#line 1437 "DatabaseTable.c"
}


void database_table_update_int_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint value, GError** error) {
	sqlite3_stmt* stmt = NULL;
	gint64 _tmp0_ = 0LL;
	const gchar* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	sqlite3_stmt* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	GError * _inner_error_ = NULL;
#line 246 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 246 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 248 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = id;
#line 248 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = column;
#line 248 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, _tmp0_, _tmp1_, &_tmp2_);
#line 248 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 248 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp2_;
#line 250 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = stmt;
#line 250 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp4_ = value;
#line 250 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_bind_int (_tmp3_, 1, _tmp4_);
#line 250 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 251 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = res;
#line 251 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp6_ == SQLITE_OK, "res == Sqlite.OK");
#line 253 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 253 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp8_ = sqlite3_step (_tmp7_);
#line 253 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp8_;
#line 254 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = res;
#line 254 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp9_ != SQLITE_DONE) {
#line 1491 "DatabaseTable.c"
		const gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gint _tmp14_ = 0;
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp10_ = self->table_name;
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp11_ = column;
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp12_ = g_strdup_printf ("DatabaseTable.update_int_by_id_2 %s.%s", _tmp10_, _tmp11_);
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp13_ = _tmp12_;
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp14_ = res;
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp13_, _tmp14_, &_inner_error_);
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_g_free0 (_tmp13_);
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 1521 "DatabaseTable.c"
			} else {
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 255 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 1531 "DatabaseTable.c"
			}
		}
	}
#line 246 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1537 "DatabaseTable.c"
}


gboolean database_table_update_int64_by_id (DatabaseTable* self, gint64 id, const gchar* column, gint64 value) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint64 _tmp0_ = 0LL;
	const gchar* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_ = NULL;
	gint res = 0;
	gint64 _tmp3_ = 0LL;
	gint _tmp4_ = 0;
	gboolean _tmp5_ = FALSE;
#line 258 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 258 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 260 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = id;
#line 260 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = column;
#line 260 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, _tmp0_, _tmp1_, &_tmp2_);
#line 260 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 260 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp2_;
#line 262 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = value;
#line 262 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_bind_int64 (stmt, 1, _tmp3_);
#line 262 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp4_;
#line 263 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 265 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = database_table_execute_update_by_id (self, stmt);
#line 265 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	result = _tmp5_;
#line 265 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 265 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return result;
#line 1581 "DatabaseTable.c"
}


void database_table_update_int64_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint64 value, GError** error) {
	sqlite3_stmt* stmt = NULL;
	gint64 _tmp0_ = 0LL;
	const gchar* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp3_ = NULL;
	gint64 _tmp4_ = 0LL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	sqlite3_stmt* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	GError * _inner_error_ = NULL;
#line 268 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 268 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 270 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = id;
#line 270 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = column;
#line 270 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, _tmp0_, _tmp1_, &_tmp2_);
#line 270 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 270 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp2_;
#line 272 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = stmt;
#line 272 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp4_ = value;
#line 272 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_);
#line 272 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 273 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = res;
#line 273 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp6_ == SQLITE_OK, "res == Sqlite.OK");
#line 275 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 275 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp8_ = sqlite3_step (_tmp7_);
#line 275 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp8_;
#line 276 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = res;
#line 276 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp9_ != SQLITE_DONE) {
#line 1635 "DatabaseTable.c"
		const gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gint _tmp14_ = 0;
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp10_ = self->table_name;
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp11_ = column;
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp12_ = g_strdup_printf ("DatabaseTable.update_int64_by_id_2 %s.%s", _tmp10_, _tmp11_);
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp13_ = _tmp12_;
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp14_ = res;
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp13_, _tmp14_, &_inner_error_);
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_g_free0 (_tmp13_);
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 1665 "DatabaseTable.c"
			} else {
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 277 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 1675 "DatabaseTable.c"
			}
		}
	}
#line 268 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1681 "DatabaseTable.c"
}


void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error) {
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	sqlite3_stmt* _tmp8_ = NULL;
	gint64 _tmp9_ = 0LL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	sqlite3_stmt* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	GError * _inner_error_ = NULL;
#line 280 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 282 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 282 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 282 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("DELETE FROM %s WHERE id=?", _tmp1_);
#line 282 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 282 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 282 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 282 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 282 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 282 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 282 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 283 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = res;
#line 283 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 285 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 285 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = id;
#line 285 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp10_ = sqlite3_bind_int64 (_tmp8_, 1, _tmp9_);
#line 285 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp10_;
#line 286 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp11_ = res;
#line 286 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp11_ == SQLITE_OK, "res == Sqlite.OK");
#line 288 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp12_ = stmt;
#line 288 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp13_ = sqlite3_step (_tmp12_);
#line 288 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp13_;
#line 289 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp14_ = res;
#line 289 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp14_ != SQLITE_DONE) {
#line 1752 "DatabaseTable.c"
		const gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gint _tmp18_ = 0;
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp15_ = self->table_name;
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp16_ = g_strdup_printf ("%s.remove", _tmp15_);
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp17_ = _tmp16_;
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp18_ = res;
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp17_, _tmp18_, &_inner_error_);
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_g_free0 (_tmp17_);
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 1779 "DatabaseTable.c"
			} else {
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 290 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 1789 "DatabaseTable.c"
			}
		}
	}
#line 280 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1795 "DatabaseTable.c"
}


gboolean database_table_has_column (const gchar* table_name, const gchar* column_name) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
#line 293 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 293 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 295 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 295 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = table_name;
#line 295 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("PRAGMA table_info(%s)", _tmp1_);
#line 295 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 295 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 295 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 295 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 295 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 295 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 295 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 296 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = res;
#line 296 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 1839 "DatabaseTable.c"
	{
		gboolean _tmp8_ = FALSE;
#line 298 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp8_ = TRUE;
#line 298 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		while (TRUE) {
#line 1846 "DatabaseTable.c"
			sqlite3_stmt* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			gint _tmp11_ = 0;
#line 298 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (!_tmp8_) {
#line 1852 "DatabaseTable.c"
			}
#line 298 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp8_ = FALSE;
#line 299 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp9_ = stmt;
#line 299 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp10_ = sqlite3_step (_tmp9_);
#line 299 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			res = _tmp10_;
#line 300 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			_tmp11_ = res;
#line 300 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_tmp11_ == SQLITE_DONE) {
#line 301 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				break;
#line 1868 "DatabaseTable.c"
			} else {
				gint _tmp12_ = 0;
#line 302 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				_tmp12_ = res;
#line 302 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				if (_tmp12_ != SQLITE_ROW) {
#line 1875 "DatabaseTable.c"
					const gchar* _tmp13_ = NULL;
					gchar* _tmp14_ = NULL;
					gchar* _tmp15_ = NULL;
					gint _tmp16_ = 0;
#line 303 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					_tmp13_ = table_name;
#line 303 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					_tmp14_ = g_strdup_printf ("has_column %s", _tmp13_);
#line 303 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					_tmp15_ = _tmp14_;
#line 303 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					_tmp16_ = res;
#line 303 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					database_table_fatal (_tmp15_, _tmp16_);
#line 303 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					_g_free0 (_tmp15_);
#line 305 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					break;
#line 1894 "DatabaseTable.c"
				} else {
					gchar* column = NULL;
					sqlite3_stmt* _tmp17_ = NULL;
					const gchar* _tmp18_ = NULL;
					gchar* _tmp19_ = NULL;
					gboolean _tmp20_ = FALSE;
					const gchar* _tmp21_ = NULL;
#line 307 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					_tmp17_ = stmt;
#line 307 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					_tmp18_ = sqlite3_column_text (_tmp17_, 1);
#line 307 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					_tmp19_ = g_strdup (_tmp18_);
#line 307 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					column = _tmp19_;
#line 308 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					_tmp21_ = column;
#line 308 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					if (_tmp21_ != NULL) {
#line 1914 "DatabaseTable.c"
						const gchar* _tmp22_ = NULL;
						const gchar* _tmp23_ = NULL;
#line 308 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
						_tmp22_ = column;
#line 308 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
						_tmp23_ = column_name;
#line 308 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
						_tmp20_ = g_strcmp0 (_tmp22_, _tmp23_) == 0;
#line 1923 "DatabaseTable.c"
					} else {
#line 308 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
						_tmp20_ = FALSE;
#line 1927 "DatabaseTable.c"
					}
#line 308 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					if (_tmp20_) {
#line 309 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
						result = TRUE;
#line 309 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
						_g_free0 (column);
#line 309 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
						_sqlite3_finalize0 (stmt);
#line 309 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
						return result;
#line 1939 "DatabaseTable.c"
					}
#line 302 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
					_g_free0 (column);
#line 1943 "DatabaseTable.c"
				}
			}
		}
	}
#line 313 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	result = FALSE;
#line 313 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 313 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return result;
#line 1954 "DatabaseTable.c"
}


gboolean database_table_has_table (const gchar* table_name) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
#line 316 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 318 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 318 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = table_name;
#line 318 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("PRAGMA table_info(%s)", _tmp1_);
#line 318 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 318 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 318 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 318 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 318 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 318 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 318 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 319 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = res;
#line 319 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 321 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp8_ = sqlite3_step (stmt);
#line 321 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp8_;
#line 323 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = res;
#line 323 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	result = _tmp9_ != SQLITE_DONE;
#line 323 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 323 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return result;
#line 2010 "DatabaseTable.c"
}


gboolean database_table_add_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	sqlite3_stmt* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	sqlite3_stmt* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
#line 326 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 326 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 326 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_constraints != NULL, FALSE);
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = table_name;
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = column_name;
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = column_constraints;
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp4_ = g_strdup_printf ("ALTER TABLE %s ADD COLUMN %s %s", _tmp1_, _tmp2_, _tmp3_);
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = sqlite3_prepare_v2 (_tmp0_, _tmp5_, -1, &_tmp6_, NULL);
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp6_;
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp8_ = _tmp7_;
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_g_free0 (_tmp5_);
#line 328 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp8_;
#line 330 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = res;
#line 330 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp9_ == SQLITE_OK, "res == Sqlite.OK");
#line 332 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp10_ = stmt;
#line 332 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp11_ = sqlite3_step (_tmp10_);
#line 332 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp11_;
#line 333 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp12_ = res;
#line 333 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp12_ != SQLITE_DONE) {
#line 2075 "DatabaseTable.c"
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		gint _tmp16_ = 0;
		sqlite3* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
#line 334 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp13_ = table_name;
#line 334 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp14_ = column_name;
#line 334 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp15_ = column_constraints;
#line 334 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp16_ = res;
#line 334 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp17_ = database_table_db;
#line 334 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp18_ = sqlite3_errmsg (_tmp17_);
#line 334 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		g_critical ("DatabaseTable.vala:334: Unable to add column %s %s %s: (%d) %s", _tmp13_, _tmp14_, _tmp15_, _tmp16_, _tmp18_);
#line 337 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		result = FALSE;
#line 337 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (stmt);
#line 337 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		return result;
#line 2102 "DatabaseTable.c"
	}
#line 340 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	result = TRUE;
#line 340 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 340 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return result;
#line 2110 "DatabaseTable.c"
}


gboolean database_table_ensure_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints, const gchar* upgrade_msg) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
#line 346 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 346 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 346 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_constraints != NULL, FALSE);
#line 346 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (upgrade_msg != NULL, FALSE);
#line 348 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = table_name;
#line 348 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = database_table_has_table (_tmp1_);
#line 348 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (!_tmp2_) {
#line 348 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp0_ = TRUE;
#line 2140 "DatabaseTable.c"
	} else {
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
#line 348 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp3_ = table_name;
#line 348 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp4_ = column_name;
#line 348 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp5_ = database_table_has_column (_tmp3_, _tmp4_);
#line 348 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp0_ = _tmp5_;
#line 2153 "DatabaseTable.c"
	}
#line 348 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp0_) {
#line 349 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		result = TRUE;
#line 349 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		return result;
#line 2161 "DatabaseTable.c"
	}
#line 351 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = upgrade_msg;
#line 351 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_message ("DatabaseTable.vala:351: %s", _tmp6_);
#line 353 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = table_name;
#line 353 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp8_ = column_name;
#line 353 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = column_constraints;
#line 353 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp10_ = database_table_add_column (_tmp7_, _tmp8_, _tmp9_);
#line 353 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	result = _tmp10_;
#line 353 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return result;
#line 2179 "DatabaseTable.c"
}


gint database_table_get_row_count (DatabaseTable* self) {
	gint result = 0;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	sqlite3_stmt* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	sqlite3_stmt* _tmp15_ = NULL;
	gint _tmp16_ = 0;
#line 356 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), 0);
#line 358 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 358 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 358 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("SELECT COUNT(id) AS RowCount FROM %s", _tmp1_);
#line 358 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 358 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 358 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 358 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 358 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 358 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 358 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 359 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp7_ = res;
#line 359 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 361 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 361 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp9_ = sqlite3_step (_tmp8_);
#line 361 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp9_;
#line 362 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp10_ = res;
#line 362 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp10_ != SQLITE_ROW) {
#line 2236 "DatabaseTable.c"
		const gchar* _tmp11_ = NULL;
		gint _tmp12_ = 0;
		sqlite3* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
#line 363 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp11_ = self->table_name;
#line 363 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp12_ = res;
#line 363 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp13_ = database_table_db;
#line 363 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp14_ = sqlite3_errmsg (_tmp13_);
#line 363 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		g_critical ("DatabaseTable.vala:363: Unable to retrieve row count on %s: (%d) %s", _tmp11_, _tmp12_, _tmp14_);
#line 365 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		result = 0;
#line 365 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (stmt);
#line 365 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		return result;
#line 2257 "DatabaseTable.c"
	}
#line 368 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp15_ = stmt;
#line 368 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp16_ = sqlite3_column_int (_tmp15_, 0);
#line 368 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	result = _tmp16_;
#line 368 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 368 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return result;
#line 2269 "DatabaseTable.c"
}


void database_table_begin_transaction (void) {
	gint _tmp0_ = 0;
	gint res = 0;
	sqlite3* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
#line 373 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_in_transaction;
#line 373 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_in_transaction = _tmp0_ + 1;
#line 373 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp0_ != 0) {
#line 374 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		return;
#line 2287 "DatabaseTable.c"
	}
#line 376 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = database_table_db;
#line 376 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = _sqlite3_exec (_tmp1_, "BEGIN TRANSACTION", NULL, NULL, NULL);
#line 376 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp2_;
#line 377 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = res;
#line 377 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 2299 "DatabaseTable.c"
}


void database_table_commit_transaction (GError** error) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint res = 0;
	sqlite3* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GError * _inner_error_ = NULL;
#line 382 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp0_ = database_table_in_transaction;
#line 382 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_vala_assert (_tmp0_ > 0, "in_transaction > 0");
#line 383 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp1_ = database_table_in_transaction;
#line 383 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_in_transaction = _tmp1_ - 1;
#line 383 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp2_ = database_table_in_transaction;
#line 383 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp2_ != 0) {
#line 384 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		return;
#line 2326 "DatabaseTable.c"
	}
#line 386 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp3_ = database_table_db;
#line 386 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp4_ = _sqlite3_exec (_tmp3_, "COMMIT TRANSACTION", NULL, NULL, NULL);
#line 386 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	res = _tmp4_;
#line 387 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_tmp5_ = res;
#line 387 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (_tmp5_ != SQLITE_DONE) {
#line 2338 "DatabaseTable.c"
		gint _tmp6_ = 0;
#line 388 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		_tmp6_ = res;
#line 388 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_throw_error ("commit_transaction", _tmp6_, &_inner_error_);
#line 388 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 388 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 388 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error_);
#line 388 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 2352 "DatabaseTable.c"
			} else {
#line 388 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 388 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error_);
#line 388 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
				return;
#line 2360 "DatabaseTable.c"
			}
		}
	}
}


DatabaseTable* database_table_construct (GType object_type) {
	DatabaseTable* self = NULL;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	self = (DatabaseTable*) g_type_create_instance (object_type);
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return self;
#line 2373 "DatabaseTable.c"
}


static void value_database_table_init (GValue* value) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	value->data[0].v_pointer = NULL;
#line 2380 "DatabaseTable.c"
}


static void value_database_table_free_value (GValue* value) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (value->data[0].v_pointer) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_unref (value->data[0].v_pointer);
#line 2389 "DatabaseTable.c"
	}
}


static void value_database_table_copy_value (const GValue* src_value, GValue* dest_value) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (src_value->data[0].v_pointer) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		dest_value->data[0].v_pointer = database_table_ref (src_value->data[0].v_pointer);
#line 2399 "DatabaseTable.c"
	} else {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2403 "DatabaseTable.c"
	}
}


static gpointer value_database_table_peek_pointer (const GValue* value) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return value->data[0].v_pointer;
#line 2411 "DatabaseTable.c"
}


static gchar* value_database_table_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (collect_values[0].v_pointer) {
#line 2418 "DatabaseTable.c"
		DatabaseTable* object;
		object = collect_values[0].v_pointer;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2425 "DatabaseTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2429 "DatabaseTable.c"
		}
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = database_table_ref (object);
#line 2433 "DatabaseTable.c"
	} else {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2437 "DatabaseTable.c"
	}
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return NULL;
#line 2441 "DatabaseTable.c"
}


static gchar* value_database_table_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DatabaseTable** object_p;
	object_p = collect_values[0].v_pointer;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (!object_p) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2452 "DatabaseTable.c"
	}
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (!value->data[0].v_pointer) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		*object_p = NULL;
#line 2458 "DatabaseTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		*object_p = value->data[0].v_pointer;
#line 2462 "DatabaseTable.c"
	} else {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		*object_p = database_table_ref (value->data[0].v_pointer);
#line 2466 "DatabaseTable.c"
	}
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return NULL;
#line 2470 "DatabaseTable.c"
}


GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecDatabaseTable* spec;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATABASE_TABLE), NULL);
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return G_PARAM_SPEC (spec);
#line 2484 "DatabaseTable.c"
}


gpointer value_get_database_table (const GValue* value) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE), NULL);
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return value->data[0].v_pointer;
#line 2493 "DatabaseTable.c"
}


void value_set_database_table (GValue* value, gpointer v_object) {
	DatabaseTable* old;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	old = value->data[0].v_pointer;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (v_object) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = v_object;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_ref (value->data[0].v_pointer);
#line 2513 "DatabaseTable.c"
	} else {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2517 "DatabaseTable.c"
	}
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (old) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_unref (old);
#line 2523 "DatabaseTable.c"
	}
}


void value_take_database_table (GValue* value, gpointer v_object) {
	DatabaseTable* old;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	old = value->data[0].v_pointer;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (v_object) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = v_object;
#line 2542 "DatabaseTable.c"
	} else {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2546 "DatabaseTable.c"
	}
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (old) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		database_table_unref (old);
#line 2552 "DatabaseTable.c"
	}
}


static void database_table_class_init (DatabaseTableClass * klass) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	database_table_parent_class = g_type_class_peek_parent (klass);
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	((DatabaseTableClass *) klass)->finalize = database_table_finalize;
#line 2562 "DatabaseTable.c"
}


static void database_table_instance_init (DatabaseTable * self) {
#line 30 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	self->table_name = NULL;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	self->ref_count = 1;
#line 2571 "DatabaseTable.c"
}


static void database_table_finalize (DatabaseTable* obj) {
	DatabaseTable * self;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DATABASE_TABLE, DatabaseTable);
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_signal_handlers_destroy (self);
#line 30 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	_g_free0 (self->table_name);
#line 2583 "DatabaseTable.c"
}


GType database_table_get_type (void) {
	static volatile gsize database_table_type_id__volatile = 0;
	if (g_once_init_enter (&database_table_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_database_table_init, value_database_table_free_value, value_database_table_copy_value, value_database_table_peek_pointer, "p", value_database_table_collect_value, "p", value_database_table_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DatabaseTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseTable), 0, (GInstanceInitFunc) database_table_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType database_table_type_id;
		database_table_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DatabaseTable", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&database_table_type_id__volatile, database_table_type_id);
	}
	return database_table_type_id__volatile;
}


gpointer database_table_ref (gpointer instance) {
	DatabaseTable* self;
	self = instance;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	return instance;
#line 2608 "DatabaseTable.c"
}


void database_table_unref (gpointer instance) {
	DatabaseTable* self;
	self = instance;
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		DATABASE_TABLE_GET_CLASS (self)->finalize (self);
#line 16 "/builddir/build/BUILD/shotwell-0.23.1/src/db/DatabaseTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2621 "DatabaseTable.c"
	}
}



